import { Entity, PrimaryKey, Property } from '@mikro-orm/core'

import { BaseEntity } from '#application/base/baseEntity'

@Entity()
export class World extends BaseEntity {
  @PrimaryKey()
  date = new Date()

  @Property()
  isRainEnabled = false

  @Property()
  rainPercentage = 0

  @Property()
  isFogEnabled = false

  @Property()
  fogDensity = 0

  setDate(date: Date) {
    this.date = date
    return this
  }

  getDate() {
    return this.date
  }

  setIsRainEnabled(isRainEnabled: boolean) {
    this.isRainEnabled = isRainEnabled
    return this
  }

  getIsRainEnabled() {
    return this.isRainEnabled
  }

  setRainPercentage(rainPercentage: number) {
    this.rainPercentage = rainPercentage
    return this
  }

  getRainPercentage() {
    return this.rainPercentage
  }

  setIsFogEnabled(isFogEnabled: boolean) {
    this.isFogEnabled = isFogEnabled
    return this
  }

  getIsFogEnabled() {
    return this.isFogEnabled
  }

  setFogDensity(fogDensity: number) {
    this.fogDensity = fogDensity
    return this
  }

  getFogDensity() {
    return this.fogDensity
  }
}
